From 90e04861aa587d192025dd42aff5501e3742672a Mon Sep 17 00:00:00 2001
From: Sylvain Munaut <tnt@246tNt.com>
Date: Thu, 24 Sep 2009 01:32:41 +0200
Subject: [PATCH 1/5] [gsm_04_11] Free transaction on RX_RP_ACK for SMS

When only one SMS is sent, the freeing of the lchan will
automatically free all transactions on the lchan.

However, if there are several SMS sent at once, the call
to gsm411_send_sms_lchan will create a new transaction
with the same caracteristics as the previous one. If
the old one is not free'd, the next call to trans_find_by_id
(triggered by the next incoming RP-ACK) will not return the good
transaction and things go haywire.

Signed-off-by: Sylvain Munaut <tnt@246tNt.com>
---
 openbsc/src/gsm_04_11.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletions(-)

diff --git a/openbsc/src/gsm_04_11.c b/openbsc/src/gsm_04_11.c
index 85fd6b6..5902074 100644
--- a/openbsc/src/gsm_04_11.c
+++ b/openbsc/src/gsm_04_11.c
@@ -650,7 +650,8 @@ static int gsm411_rx_rp_ack(struct msgb *msg, struct gsm_trans *trans,
 	sms_free(sms);
 	trans->sms.sms = NULL;
 
-	/* do not free the transaction here, this is done by sending CP-ACK */
+	/* free the transaction here */
+	trans_free(trans);
 
 	/* check for more messages for this subscriber */
 	sms = db_sms_get_unsent_for_subscr(msg->lchan->subscr);
-- 
1.6.4

